import java.util.Scanner;
public class Doces {
	//Vetor que conter as quantidades de cada um dos di doces.  esttico, pois ser alterado por mais de uma funo
	public static int[] di;
	//Mtodo que retorna se uma pessoa ficou satisfeita (true) ou no (false)
	public static boolean estaSatisfeito(int preferencia){
		if(di[preferencia] > 0) return true;
		return false;
	}
	
	/* 
	 * Mtodo que conta quantas pessoas ficaram satisfeitas.
	 * Independente se a pessoa ficou satisfeito com a preferncia 1, o programa faz uma chamada recursiva
	 * para a prxima pessoa. Ele verifica todas as pessoas, contando um quando a pessoa ficou satisfeita e
	 * sempre verifica primeiro a preferncia 1 e depois a dois. Ao final de todas as chamadas recursivas
	 * a funo analisou todas as combinaes de preferncias e retorna a quantidade de pessoas satisfeitas na melhor
	 * das combinaes. 
	 * */
	
	public static int satisfeitos(int[][]pi, int pessoa, int p){
		//Condio de parada das chamadas recursivas (atingiu o fim do vetor de preferncias)
		if(pessoa > p) return 0;
		
		//Como o algoritmo  inspirado em percuso de ABB, chamei de esq em referncia ao n esquerdo da rvore
		int esq = 0;
		
		/*Verifica a opo 1 da pessoa, caso ela fique satisfeita, remove um da quantidade de doces do tipo que ela quer,
		 * vai para a prxima pessoa recursivamente, adicionando um na varivel esq. Quando retorna da chamada recursiva, 
		 * o doce removido tem que ser reincrementado para que a verificao da segunda opo seja feita nas mesmas
		 * condies que a primeira.
		 * Caso a pessoa no fique satisfeita com a primeira opo, a chamada recursiva para a prxima pessoa  feita
		 * do mesmo jeito, mas nenhum doce  decrementado do vetor de quantidades, pois a pessoa no pegar o doce. E no
		 * adiciona um na varivel esq, pois a pessoa no ficou satisfeita
		 * */
		if(estaSatisfeito(pi[0][pessoa])){
			di[pi[0][pessoa]]--;
			esq = 1 + satisfeitos(pi, pessoa+1, p);
			di[pi[0][pessoa]]++;
			
		}else{
			esq += satisfeitos(pi, pessoa+1, p);
		}
		
		
		/* O equema dessa chamada recursiva  espelhado com o da primeira preferncia
		 * Aqui, quando a segunda opo da pessoa satisfaz ela,  decrementado um da quantidade do doce que ela quer,
		 *  feita uma chamada recursiva para a prxima pessoa e, aps a chamada recursiva retornar,  reincrementado o valor
		 * da quantidade. Caso a pessoa no fique satisfeita com aquela opo, a chamada recursiva  feita do mesmo jeito,
		 * mas no incrementa um na varivel dir, pois a pessoa no ficou satisfeita.
		 * */
		int dir = 0;
		if(estaSatisfeito(pi[1][pessoa])){
			di[pi[1][pessoa]]--;
			dir = 1 + satisfeitos(pi, pessoa+1, p);
			di[pi[1][pessoa]]++;
			
		}else{
			dir += satisfeitos(pi, pessoa+1, p);
		}
		
		//Verifica qual contador obteve o melhor resultado, escolhendo a primeira ou a segunda preferncia
		if(esq > dir) return esq;
		else return dir;
	}
	
	//Mtodo principal que pega as entradas, processa e retorna o output correto
	public static void main(String[] args) {
		
		//Objeto do tipo Scanner que contm os mtodos para receber a entrada do teclado
		Scanner scan = new Scanner(System.in);
		
		//Varivel que armazena o nmero de casos de teste
		int n = scan.nextInt();
		
		//Lao que processa cada caso de teste
		for(int i = 0; i < n; i++){
			
			//Recebe os nmeros totais de tipos doces e de pessoas
			int d, p;
			d = scan.nextInt();
			p = scan.nextInt();
			//Inicializa o vetor de doces com d+1 para fazer fazer a correspondncia direta entre as preferncias
			//das pessoas e os doces no vetor
			di = new int[d+1];
			
			//Matriz em que a primeira linha contm, em cada coluna, as primeiras opes de doce da respectiva pessoa
			//Na segunda linha, a mesma coisa para as segundas opes. p+1 tambm serve para fazer a correspondncia direta
			int[][] pi = new int[2][p+1];
			
			//Recebe as quantidades de cada tipo de doce
			for(int j = 1; j <= d; j++){
				di[j] = scan.nextInt();
			}
			
			//Recebe as primeiras opes
			for(int j = 1; j <= p; j++){
				pi[0][j] = scan.nextInt();
			}
			
			//Recebe as segundas opes
			for(int j = 1; j <= p; j++){
				pi[1][j] = scan.nextInt();
			}
			//Chama a funo que calcula o nmero de pessoas satisfeitas e exibe essa resposta
			System.out.println(satisfeitos(pi, 1, p));
		}
	}
}
